<?php

namespace App\Service;

class IntegrationRequest {
    public function send($url, $options = []) {
        $curl = curl_init();

        $curlOptions = [
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => $options['method'] ?? 'GET',
            CURLOPT_HTTPHEADER => ["Authorization: Bearer " . $accessToken],
        ];
        
        if (isset($options['data'])) {
            $curlOptions['CURLOPT_POSTFIELDS'] = $options['data'];
        }
        if ($_ENV['INTEGRATION_USE_SSL'] === 'NO') {
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);    
        } 

        curl_setopt_array($curl, $curlOptions);
        

        $curlResponse = curl_exec($curl);
        $errorMessage = curl_errno($curl);
    }
    
    public function get($url, $data = []) {
        $queryParams = empty($data) ? "" : "?" . http_build_query($data);
        return $this->send($url . $queryParams);
    }
    public function patch($url, $data) {
        return $this->send($url, ['method' => 'PATCH', 'data' => $data]);
    }
}